//generisches Fachwerk - joeydee - V0.1
$fn=30;//Anzahl Segmente für Rundungen
nozzle=0.4;//kleinste Linienbreite

//---------------------- Beispiele

//leerer Rahmen
translate([0, 40,0])framework(43,12);

//Holz
translate([0, 20,0])framework(150,16,"|A|V|Z|O|X|N.Z|C...D|N|#|.|");
translate([0,  0,0])framework(52,16,"|N| | | . | |Z|",bar2=4);//Fachwerkhaus
translate([0, -15,0])framework(20,12,".D|", pileH=0.8, pileW=1.2, frameW=1.2);//Torbogen

//Stahl
translate([0,-40,0])framework(80,15,"...>|.|>.<|",offset=1,frameW=1.7, pileW=2, gridW=0.8, beam=true);
translate([0,-55,0])framework(80,10,"|V|V|V|",frameW=1.5, pileW=1, gridW=0.45, beam=true);
translate([0,-70,0])framework(80,7,"|V.V.V.V.V|",frameH=0.5, frameW=1.5, pileH=0.3, pileW=1, gridH=0.3, gridW=0.45, beam=true);
translate([0,-85,0])framework(70,10,".N|Z|N|Z|N|Z.",frameH=0.8, frameW=1.5, pileH=0.4, pileW=1, gridH=0.2, gridW=0.45, beam=true);
translate([0,-100,0])framework(70,10,".X|X|X|X|X|X.",frameW=1.5, pileW=1, gridW=0.45, gridH=0.45, beam=true);
translate([0,-110,0]) framework(30,6,"|V|V|V|", frameH=0.5, frameW=0.7, pileH=0.4, pileW=0.5, gridH= 0.25, gridW=0.41);

//Geländer, provisorisch (hier 1/160; 7mm -> ca. 110cm Höhe)
translate([0,-130,0])framework(90,7,"| | | | | |",frameW=0.6, frameH=0.8,  pileH=0.6, bar2=4.2, gridW=0.45, gridH=3);
translate([0,-140,0])framework(85,7,"|||||||",frameW=0.6, frameH=1.2, gridW=0.45, gridH=0.3);
translate([0,-150,0])framework(85,7,"|-|-|-|",frameW=0.45, frameH=0.3, pileW=0.8, pileH=0.8, gridW=0.45, gridH=0.3);

//---------------------- 

//w,h: Außenmaße
//pattern: Musterabfolge (jeweils Pfosten/Fach/Pfosten/...)
//offset: offsetset für Schrägbalken
//bar2, bar3: weitere durchgehende Längsbalken, Abstand von unten
//Materialbreiten: frameW = Längsbalken, pileW = senkrechte Pfosten, gridW = Querstreben
//Materialstärken (Z-Achse): frameH = Längsbalken, pileH = senkrechte Pfosten, gridH = Querstreben



module framework(w,h,pattern="|.|", offset=0.5, bar2=0, bar3=0, frameH=1, pileH=0.8, gridH=0.6, frameW=1, pileW=1, gridW=1, beam=false){
    
    //horizontal beams
    beamX([w,frameW,frameH],mh=pileH,beam=beam);
    translate([0,h-frameW,0]) beamX([w,frameW*1,frameH],mh=pileH,beam=beam);
    if(bar2>0)translate([0,bar2,0]) cube([w,gridW,pileH]);
    if(bar3>0)translate([0,bar3,0]) cube([w,gridW,pileH]);

    l=len(pattern);
    num=floor(l/2);
    wid=(w-pileW)/num;
    hig=(h-frameW*2);

    w1=wid-2*offset-pileW;
    alphaX=-atan2(w1,hig);
    lenX=sqrt(w1*w1+hig*hig)+frameW/2;
    
    w2=(w1-offset*0.5)/2;
    alphaV=-atan2(w2,hig);
    lenV=sqrt(w2*w2+hig*hig)+pileW/2;

    o2=gridW*0.7;
    h3=hig/2-o2;
    w3=wid-pileW-offset;
    alphaQ=-atan2(w3,h3);
    lenQ=sqrt(w3*w3+h3*h3)+gridW;
    
    plx=max(pileW,o2*6);
    ply=o2*6;

    for(i=[0:1:num]){
        translate([i*wid,0,0]){
            
            //vertical beams
            v=pattern[i*2];
            if(v=="|")beamY([pileW,h,pileH],mh=gridH,beam=beam);
            if(v=="*")translate([pileW/2,hig/2+frameW,pileH/2]) cube([plx,ply,pileH], center=true);

            //patterns
            c=pattern[i*2+1];
            if(c=="|")translate([wid/2+pileW/2,hig/2+frameW,pileH/2]) beamY([pileW,h,pileH], mh=gridH, center=true);
            if(c=="Z" || c=="X")
                translate([wid/2+pileW/2,hig/2+frameW,0]) 
                 rotate([0,0,alphaX]) 
                 translate([0,0,gridH/2]) 
                 cube([gridW,lenX,gridH], center=true);
            if(c=="N" || c=="X")
                translate([wid/2+pileW/2,hig/2+frameW,0]) 
                 rotate([0,0,-alphaX]) 
                 translate([0,0,gridH/2]) 
                 cube([gridW,lenX,gridH], center=true);
            if(c=="A"){
                translate([wid/2+pileW/2-w1/4-offset/4,hig/2+frameW,0]) 
                 rotate([0,0,alphaV]) 
                 translate([0,0,gridH/2]) 
                 cube([gridW,lenV,gridH], center=true);
                translate([wid/2+pileW/2+w1/4+offset/4,hig/2+frameW,0]) 
                 rotate([0,0,-alphaV]) 
                 translate([0,0,gridH/2]) 
                 cube([gridW,lenV,gridH], center=true);
            }
            if(c=="V"){
                translate([wid/2+pileW/2+w1/4+offset/4,hig/2+frameW,0]) 
                 rotate([0,0,alphaV]) 
                 translate([0,0,gridH/2]) 
                 cube([gridW,lenV,gridH], center=true);
                translate([wid/2+pileW/2-w1/4-offset/4,hig/2+frameW,0]) 
                 rotate([0,0,-alphaV]) 
                 translate([0,0,gridH/2]) 
                 cube([gridW,lenV,gridH], center=true);
            }
            if(c==">"){
                translate([pileW+offset,frameW,0]) 
                 rotate([0,0,alphaQ]) 
                 translate([0,lenQ/2-gridW/2,gridH/2]) 
                 cube([gridW,lenQ,gridH], center=true);
                translate([pileW+offset,frameW+hig,0]) 
                 rotate([0,0,180-alphaQ]) 
                 translate([0,lenQ/2-gridW/2,gridH/2]) 
                 cube([gridW,lenQ,gridH], center=true);
                translate([pileW/2+wid-plx/4,hig/2+frameW,pileH/2+0.2]) cube([plx/2,ply,pileH], center=true);
            }
            if(c=="<"){
                translate([wid-offset,frameW,0]) 
                 rotate([0,0,-alphaQ]) 
                 translate([0,lenQ/2-gridW/2,gridH/2]) 
                 cube([gridW,lenQ,gridH], center=true);
                translate([wid-offset,frameW+hig,0]) 
                 rotate([0,0,alphaQ-180]) 
                 translate([0,lenQ/2-gridW/2,gridH/2]) 
                 cube([gridW,lenQ,gridH], center=true);
                translate([pileW/2+plx/4,hig/2+frameW,pileH/2+0.2]) cube([plx/2,ply,pileH], center=true);

            }
            if(c=="-"){
                 translate([wid/2+pileW/2,hig/2+frameW,gridH/2]) 
                 cube([wid,gridW,gridH], center=true);
            }
            if(c=="O"){
                r=min((hig+gridW)/2,(w1+gridW+offset*2)/2);
                translate([wid/2+pileW/2,hig/2+frameW,0]){
                    difference(){
                        cylinder(gridH,r,r);
                        translate([0,0,-gridH]) cylinder(gridH*3,r-gridW,r-gridW);
                    }
                }
            }
            if(c=="C" || c=="D"){
                //r=min((hig+gridW)/2,(w1+gridW+offset*2)/2);
                r=hig/2+gridW;
                translate([(c=="C"?r+pileW:-r+wid),hig/2+frameW,0]){ //[wid/2+pileW/2,hig/2+frameW,0]
                    difference(){
                        cylinder(gridH,r,r);
                        translate([0,0,-gridH]) cylinder(gridH*3,r-gridW,r-gridW);
                        translate([c=="C"?r:-r,0,0]) cube([r*2,r*2,20], center=true);
                    }
                }
            }
            
            if(c=="#"){
                translate([wid/2+pileW/2,hig/2+frameW,gridH/2])
                difference(){
                    cube([wid,h,gridH], center=true);
                    translate([0,0,0]) 
                    scale([1,1.8,1])
                    rotate([0,0,45])
                    cube([h/3,h/3,gridH*3], center=true);
                }
            }
            
        }
    }
}

//I-Beams statt Cubes (X- und Y-Richtung) 
module beamX(sizes,center=false,mh=0.2,beam=false){
    if(beam){
        m=nozzle+0.01;
        wx=sizes[0];
        wy=sizes[1];
        wz=sizes[2];
        //translate([center?-wx/2:0,center?-wy/2:0,center?-wz/2:0]){
        translate(center?-sizes/2:[0,0,0]){
            translate([0,0,0]) cube([wx,wy,mh]);
            cube([wx,m,wz]);
            translate([0,wy-m,0]) cube([wx,m,wz]);
        }
    }
    else cube(sizes,center);
}

module beamY(sizes,center=false,mh=0.2,beam=false){
    ySizes=[sizes[1],sizes[0],sizes[2]];
    translate(!center?sizes/2:[0,0,0]){
        rotate([0,0,90]) beamX(ySizes,center=true,beam=beam);
    }
}

